<?php
/**
* 2015-2016 YDRAL.COM
*
* NOTICE OF LICENSE
*
*  @author    YDRAL.COM <info@ydral.com>
*  @copyright 2015-2019 YDRAL.COM
*  @license   GNU General Public License version 2
*
* You can not resell or redistribute this software.
*/

if (!defined('_PS_VERSION_')) {
    exit;
}

require_once _PS_MODULE_DIR_ . '/correos/classes/CorreosCommon.php';
require_once _PS_MODULE_DIR_ . '/correos/classes/helper/CorreosDebug.php';

class FrontParamsShipping
{
    public static function officeShippingWiew($cart, $carrier)
    {
        $address = new Address($cart->id_address_delivery);
        $customer = new Customer($cart->id_customer);
        $correos_config = CorreosCommon::getCorreosConfiguration();
        $request_data = CorreosCommon::getRequestData($cart->id, $carrier['id']);

        $postcode = $address->postcode;

        if ((isset($request_data->id_address_delivery)
            && $request_data->id_address_delivery == $cart->id_address_delivery)
            && isset($request_data->reference)) {
            $postcode = $request_data->reference;
        } elseif (!isset($request_data->id_address_delivery) && isset($request_data->reference)) {
            $postcode = $request_data->reference;
        }

        // Celta Byte
        $email = isset($request_data->email) && !empty($request_data->email) ? $request_data->email : $customer->email;
        $email = strpos($email, 'noreply') === 0 ? '' : $email;
        $mobile = isset($request_data->mobile->number) ? trim($request_data->mobile->number) : isset($address->phone_mobile) ? $address->phone_mobile : '';
        $mobile = $mobile ? $mobile : '';

        return array(
            'carrier_type' => 'office',
            'delivery_option' => $cart->id_carrier,
            'cr_client_postcode' => $postcode,
            'cr_client_mobile' => $mobile,
            'cr_client_email' => $email,
            'id_carrier' => (int) $carrier['id'],
            'correos_config' => $correos_config,
        );
    }

    public static function homepaqShippingView($cart, $carrier)
    {
        $address = new Address($cart->id_address_delivery);
        $customer = new Customer($cart->id_customer);
        $correos_config = CorreosCommon::getCorreosConfiguration();
        $request_data = CorreosCommon::getRequestData($cart->id, $carrier['id']);
        $postcode = $address->postcode;

        if ((isset($request_data->id_address_delivery) && $request_data->id_address_delivery == $cart->id_address_delivery)
            && isset($request_data->reference)) {
            $postcode = $request_data->reference;
        } elseif (!isset($request_data->id_address_delivery) && isset($request_data->reference)) {
            $postcode = $request_data->reference;
        }

        // Celta Byte
        $email = isset($request_data->email) && !empty($request_data->email) ? $request_data->email : $customer->email;
        $email = strpos($email, 'noreply') === 0 ? '' : $email;
        $mobile = isset($request_data->mobile->number) ? trim($request_data->mobile->number) : isset($address->phone_mobile) ? $address->phone_mobile : '';
        $mobile = $mobile ? $mobile : '';

        return array(
            'carrier_type' => 'homepaq',
            'cr_client_mobile' => $mobile,
            'cr_client_email' => $email,
            'cr_client_postcode' => $postcode,
            'id_carrier' => (int) $carrier['id'],
            'correos_config' => $correos_config,
            'request_data' => $request_data,
        );
    }

    public static function internationalShippingView($cart, $carrier)
    {
        $address = new Address($cart->id_address_delivery);

        $correos_config = CorreosCommon::getCorreosConfiguration();
        $id_zone = State::getIdZone($address->id_state);
        $show_customs_message = false;
        if (!$id_zone) {
            $id_zone = Address::getZoneById($cart->id_address_delivery);
        }
        if ($correos_config['customs_zone'] != '') {
            $customs_zone = Tools::jsonDecode($correos_config['customs_zone']);
            if (in_array($id_zone, $customs_zone)) {
                $show_customs_message = true;
            }
        }
        $request_data = CorreosCommon::getRequestData($cart->id, $carrier['id']);

        $mobile = isset($request_data->mobile) ? $request_data->mobile : $address->phone_mobile;
        $mobile = $mobile ? $mobile : '';

        return array(
                'carrier_type' => 'international',
                'show_customs_message' => $show_customs_message,
                'mobile' => $mobile,
                'id_carrier' => (int) $carrier['id'],
        );
    }

    public static function isPrestashop17()
    {
        return version_compare(_PS_VERSION_, '1.7', '>');
    }

    public static function isPrestashop16()
    {
        return !self::isPrestashop17();
    }
}
