<?php
/**
* 2015-2016 YDRAL.COM
*
* NOTICE OF LICENSE
*
*  @author    YDRAL.COM <info@ydral.com>
*  @copyright 2015-2019 YDRAL.COM
*  @license   GNU General Public License version 2
*
* You can not resell or redistribute this software.
*/

if (!defined('_PS_VERSION_')) {
    exit;
}

require_once _PS_MODULE_DIR_ . '/correos/classes/CorreosCommon.php';

class UpdateOrderShippingNumberOnUpdatedStatus
{
    private $order;
    private $orderStatusId;

    public function __construct($order, $orderStatusId)
    {
        $this->order = $order;
        $this->orderStatusId = $orderStatusId;
    }

    public function __invoke()
    {
        if ($this->notCorreosCarrierOrder()) {
            return;
        }

        if ($this->notCorreosOrderStatus()) {
            return;
        }

        $this->updateShippingNumber();
    }

    private function updateShippingNumber()
    {
        $tracking_number = $this->order->getWsShippingNumber();

        if (empty($tracking_number)) {
            return;
        }

        $this->order->shipping_number = $tracking_number;
        $this->order->update();
    }

    private function notCorreosCarrierOrder()
    {
        $carrier = new Carrier((int) $this->order->id_carrier);

        if ($carrier->external_module_name === 'correos') {
            return false;
        }

        return true;
    }

    private function notCorreosOrderStatus()
    {
        $correosOrderStatusIds = Tools::jsonDecode(
            CorreosCommon::getCorreosConfiguration('order_states')
        );

        if (!in_array($this->orderStatusId, $correosOrderStatusIds)) {
            return true;
        }

        return false;
    }
}
