<?php
/**
* 2019 WOOENVIO.ES
*
* NOTICE OF LICENSE
*
*  @author    WOOENVIO.ES <info@wooenvio.es>
*  @copyright 2019 WOOENVIO.ES
*  @license   GNU General Public License version 2
*
* You can not resell or redistribute this software.
*/

if (!defined('_PS_VERSION_')) {
    exit;
}
require_once _PS_MODULE_DIR_ . '/correos/classes/CorreosCommon.php';

class CorreosTracking
{
    const URL_BASE = 'https://localizador.correos.es/canonico/eventos_envio_servicio_auth/';

    public static function getTracking($shipping_code, $correos_config = null, $mock_result = null)
    {
        if (is_null($correos_config)) {
            $correos_config = CorreosCommon::getCorreosConfiguration();
        }
        $ch = curl_init(self::urlRequest($shipping_code));
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt(
            $ch,
            CURLOPT_HTTPHEADER,
            [
                'Content-Type:application/json',
            ]
        );
        curl_setopt($ch, CURLOPT_USERPWD, $correos_config['correos_user'] . ':' . $correos_config['correos_password']);

        $result = curl_exec($ch);

        if ($result === false) {
            CorreosDebug::log('Curl error: ' . curl_error($ch));
            $err = 'Curl error: ' . curl_error($ch);
            curl_close($ch);
            return $err;
        }
        curl_close($ch);

        return self::processResult(is_null($mock_result) ? $result : $mock_result);
    }

    private static function urlRequest($shipping_code)
    {
        return sprintf(
            '%s%s?codIdioma=ES&indUltEvento=N',
            self::URL_BASE,
            $shipping_code
        );
    }

    private static function processResult($result)
    {
        $results = json_decode($result);

        if (isset($results[0]->error->codError) && $results[0]->error->codError != 0) {
            return $results[0]->error->desError;
        }

        return array_map(function ($row) {
            return array_map(function ($evento) {
                $object = new stdClass();
                $object->Estado = $evento->desTextoResumen;
                $object->Fecha = $evento->fecEvento;

                return $object;
            }, $row->eventos);
        }, $results);
    }
}
