/**
* 2019-2020 Celta Byte SL
*
* NOTICE OF LICENSE
*
*  @author Celta Byte SL <info@wooenvio.es>
*  @license GNU General Public License version 2
*
* You can not resell or redistribute this software.
*/

Correos.token = typeof static_token === 'undefined' ? '' : static_token;

var bestKitActive = function() {
  return $( "#opc_wrapper" ).length >= 0;
}
var onePageCheckoutActive = function() {
  return jQuery(".delivery_option_radio").length >= 0;
}

var isCorreosOfficeShippingSelected = function() {
  return CorreosConfig.carrierOffice.map(Number).indexOf(CorreosConfig.selectedCarrier) >= 0;
}

var isCorreosHourSelectingShippingSelected = function() {
  return CorreosConfig.carrierHourselect.map(Number).indexOf(CorreosConfig.selectedCarrier) >= 0;
}

var isCorreosInternacionalShippingSelected = function() {
  return CorreosConfig.carrierInternacional.map(Number).indexOf(CorreosConfig.selectedCarrier) >= 0;
}

var isCorreosCityPaqShippingSelected = function() {
  return CorreosConfig.carrierCityPaq.map(Number).indexOf(CorreosConfig.selectedCarrier) >= 0
}

if(jQuery("input[type=radio][name=id_carrier]:checked").length) {
  var carrier_array = $('input[type=radio][name=id_carrier]:checked').val().split(',').map(function(x){return parseInt(x)});
  CorreosConfig.selectedCarrier = carrier_array[0];
}

if(jQuery(".delivery_option_radio:checked").length) {
  var carrier_array = $('input[type=radio].delivery_option_radio:checked').val().split(',').map(function(x){return parseInt(x)});
  CorreosConfig.selectedCarrier = carrier_array[0];
}

if(jQuery("input[type=radio][name=id_carrier]:checked").length) { // PS 1.4
  var carrier_array = $('input[type=radio][name=id_carrier]:checked').val().split(',').map(function(x){return parseInt(x)});
  CorreosConfig.selectedCarrier = carrier_array[0];
}

if(jQuery(".supercheckout_shipping_option").length) {
  if(jQuery("#supercheckout_correos_carrier").length)
    $("#supercheckout_correos_carrier").remove();
}

if(isCorreosOfficeShippingSelected()) {
  if(jQuery(".supercheckout_shipping_option").length) {
    $('input[type=radio].supercheckout_shipping_option:checked').parents('tr').after('<tr class="highlight" id="supercheckout_correos_carrier"><td colspan="3"></td></tr>');
    $('#supercheckout_correos_carrier').css("border-bottom", "1px solid #f2f2f2");
  }

  if (CorreosConfig.presentationMode == 'popup') {
    if(jQuery(".supercheckout_shipping_option").length) {
      $('#supercheckout_correos_carrier td').append($('#correos_popuplinkcontent'));
    } else if(onePageCheckoutActive()) {
      $('input[type=radio].delivery_option_radio:checked').closest( ".delivery_option").find(".delivery_option_logo").next().append($('#correos_popuplinkcontent'));
    } else {
      $('input[type=radio][name=id_carrier]:checked').parents('tr').find(".carrier_infos").append($('#correos_popuplinkcontent'));
    }
  } else {
    if(jQuery(".supercheckout_shipping_option").length) {
      //$('#supercheckout_correos_carrier td').append($('#correos_content'));
      //$('#supercheckout_correos_carrier td').append($('#correos_content'));
      setTimeout(function(){
        $('#supercheckout_correos_carrier td').append($('#correos_content'));
      }, 100);

    } else if(onePageCheckoutActive()) {
      $('input[type=radio].delivery_option_radio:checked').closest( ".delivery_option" ).append($('#correos_content'));
    } else {
      $('input[type=radio][name=id_carrier]:checked').parents('tr').after($('#correos_content'));
    }
    $( "#loadingmask" ).remove();
    $( "#correosOffices_content" ).before('<div id="loadingmask"> <img src="'+CorreosConfig.moduleDir+'views/img/opc-ajax-loader.gif" alt="" />'+CorreosMessage.loading+'</div>');


    if (Correos.postcode_from_map != '') {
      $("#correos_postcode").val(Correos.postcode_from_map);
    }
    Correos.getOffices();
  }

} else {
  $('#correosOffices_content').css("display","none");
  $('#message_no_office_error').css("display","none");
}

if (isCorreosHourSelectingShippingSelected()) {
  if(jQuery(".supercheckout_shipping_option").length) {
    $('input[type=radio].supercheckout_shipping_option:checked').parents('tr').after('<tr class="highlight" id="supercheckout_correos_carrier"><td colspan="3"></td></tr>');
    $('#supercheckout_correos_carrier').css("border-bottom", "1px solid #f2f2f2");
  }
  if(jQuery(".supercheckout_shipping_option").length)
    $('#supercheckout_correos_carrier td').append($('#timetable'));
  else if(onePageCheckoutActive())
    $('input[type=radio].delivery_option_radio:checked').closest( ".delivery_option" ).append($('#timetable'));
  else
    $('input[type=radio][name=id_carrier]:checked').parents('tr').after($('#timetable'));
  $('#timetable').fadeIn();
} else {
  $('#timetable').fadeOut();
}

if (isCorreosInternacionalShippingSelected()) {
  if(jQuery(".supercheckout_shipping_option").length) {
    $('input[type=radio].supercheckout_shipping_option:checked').parents('tr').after('<tr class="highlight" id="supercheckout_correos_carrier"><td colspan="3"></td></tr>');
    $('#supercheckout_correos_carrier').css("border-bottom", "1px solid #f2f2f2");
  }
  if(jQuery(".supercheckout_shipping_option").length)
    $('#supercheckout_correos_carrier td').append($('#cr_internacional'));
  else if(onePageCheckoutActive())
    $('input[type=radio].delivery_option_radio:checked').closest( ".delivery_option" ).append($('#cr_internacional'));
  else
    $('input[type=radio][name=id_carrier]:checked').parents('tr').after($('#cr_internacional'));
  $('#cr_internacional').fadeIn();
  Correos.updateInternationalMobile();
  //Correos.tooglePaymentModules();
} else {
  $('#cr_internacional').fadeOut();
}

if (isCorreosCityPaqShippingSelected()) {
  if(jQuery(".supercheckout_shipping_option").length) {
    $('input[type=radio].supercheckout_shipping_option:checked').parents('tr').after('<tr class="highlight" id="supercheckout_correos_carrier"><td colspan="3"></td></tr>');
    $('#supercheckout_correos_carrier').css("border-bottom", "1px solid #f2f2f2");
  }

  if (CorreosConfig.presentationMode == 'popup') {

    if(jQuery(".supercheckout_shipping_option").length) {
      $('#supercheckout_correos_carrier td').append($('#correos_popuplinkcontentpaq'));
    } else if(jQuery("#onepagecheckoutps_step_two .delivery_option_radio").length) {
      $('#correos_popuplinkcontentpaq').addClass('pull-right');
      $('#onepagecheckoutps_step_two .delivery_option.selected > div').append($('#correos_popuplinkcontentpaq'));
    } else {
      $('input[type=radio][name=id_carrier]:checked').parents('tr').find(".carrier_infos").append($('#correos_popuplinkcontentpaq'));
    }

    if(onePageCheckoutActive()) {
      $('input[type=radio].delivery_option_radio:checked').closest( ".delivery_option").find(".delivery_option_logo").next().append($('#correos_popuplinkcontentpaq'));
    } else {
      $('input[type=radio][name=id_carrier]:checked').parents('tr').find(".carrier_infos").append($('#correos_popuplinkcontentpaq'));
    }

  } else {
    $( "#loadingmask" ).remove();

    if(jQuery(".supercheckout_shipping_option").length) {
      $('#supercheckout_correos_carrier td').append($('#correospaq'));
    } else if(bestKitActive()){
      $('#correospaq').fadeIn();
    } else if(onePageCheckoutActive()) {
      var element = $('#correospaq').clone();
      $('#correospaq').remove();
      $('input[type=radio].delivery_option_radio:checked').closest( ".delivery_option").append(element);
      $('#correospaq').fadeIn();
    } else {
      $('input[type=radio][name=id_carrier]:checked').parents('tr').after($('#correospaq'));
    }
  }

} else {
  $('#correospaq').fadeOut();
}

Correos.tooglePaymentModules(CorreosConfig.selectedCarrier);  
